<?php

namespace Drupal\entity_generic\Generic;

/**
 * Provides an interface defining a "hidden" flow.
 */
interface EntityHiddenInterface {

  /**
   * Determines whether the entity is hidden.
   *
   * @return bool
   *   The bool value for hidden state.
   */
  public function isHidden();

  /**
   * Sets the "hidden" state for entity.
   *
   * @param bool $status
   *
   * @return \Drupal\Core\Entity\EntityInterface
   *   The called entity.
   */
  public function setHidden($status);

}
