<?php

namespace Drupal\entity_generic\Generic;

/**
 * Implements "hidden" functionality for the entity.
 */
trait EntityHiddenTrait {

  /**
   * A hidden state.
   *
   * @var string
   */
  protected $hidden;

  /**
   * {@inheritdoc}
   */
  public function isHidden() {
    return (bool) $this->hidden;
  }

  /**
   * {@inheritdoc}
   */
  public function setHidden($hidden_status) {
    return $this->set('hidden', $hidden_status);
  }

}
