<?php

namespace Drupal\entity_generic\Generic;

/**
 * Provides an interface defining a "locked" flow.
 */
interface EntityLockedInterface {

  /**
   * Determines whether the entity is locked.
   *
   * @return string|false
   *   The module name that locks the type or FALSE.
   */
  public function isLocked();

  /**
   * Sets the "locked" state for entity.
   *
   * @param $locker
   *
   * @return \Drupal\Core\Entity\EntityInterface
   *   The called entity.
   */
  public function setLock($locker);

  /**
   * Releases the "lock".
   *
   * @return \Drupal\Core\Entity\EntityInterface
   *   The called entity.
   */
  public function releaseLock();

}
