<?php

namespace Drupal\entity_generic\Plugin\Action;

use Drupal\Core\Action\Plugin\Action\EntityActionBase;
use Drupal\Core\Session\AccountInterface;
use Drupal\entity_generic\Generic\EntityStatusInterface;


/**
 * @Action(
 *   id = "entity:disable_action",
 *   label = @Translation("Disable entity"),
 *   deriver = "Drupal\entity_generic\Plugin\Action\Derivative\DisableActionDeriver",
 * )
 */
class DisableAction extends EntityActionBase {

  /**
   * {@inheritdoc}
   */
  public function execute($entity = NULL) {
    $entity->setStatus(EntityStatusInterface::ENTITY_DISABLED);
    $entity->save();
  }

  /**
   * {@inheritdoc}
   */
  public function access($object, AccountInterface $account = NULL, $return_as_object = FALSE) {
    $result = $object->access('update', $account, TRUE)
      ->andIf($object->status->access('edit', $account, TRUE));

    return $return_as_object ? $result : $result->isAllowed();
  }

}
